#if defined _cstrike_to_fakemeta_included
  #endinput
#endif
#define _cstrike_to_fakemeta_included

#if !defined _fakemeta_included
	#include <fakemeta>
#endif



#define EXTRAOFFSET_WEAPONS		4 
#define ACTUAL_EXTRA_OFFSET		20

#define OFFSET_ARMORTYPE		112
#define OFFSET_TEAM			114
#define OFFSET_CSMONEY			115
#define OFFSET_PRIMARYWEAPON		116
#define OFFSET_LASTACTIVITY		124
#define OFFSET_INTERNALMODEL		126
#define OFFSET_NVGOGGLES		129
#define OFFSET_DEFUSE_PLANT		193
#define OFFSET_VIP			209
#define OFFSET_TK			216 
#define OFFSET_HOSTAGEKILLS		217
#define OFFSET_MAPZONE			235
#define OFFSET_ISDRIVING		350 
#define OFFSET_STATIONARY		362 
#define OFFSET_ZOOMTYPE			363

#define OFFSET_AWM_AMMO			377 
#define OFFSET_SCOUT_AMMO		378
#define OFFSET_PARA_AMMO		379
#define OFFSET_FAMAS_AMMO		380
#define OFFSET_M3_AMMO			381
#define OFFSET_USP_AMMO			382
#define OFFSET_FIVESEVEN_AMMO		383
#define OFFSET_DEAGLE_AMMO		384
#define OFFSET_P228_AMMO		385
#define OFFSET_GLOCK_AMMO		386
#define OFFSET_FLASH_AMMO		387
#define OFFSET_HE_AMMO			388
#define OFFSET_SMOKE_AMMO		389
#define OFFSET_C4_AMMO			390

#define OFFSET_CSDEATHS			444 
#define OFFSET_SHIELD			510
// "weapon_*" entities
#define OFFSET_WEAPONTYPE		43 
#define OFFSET_CLIPAMMO			51 
#define OFFSET_SILENCER_FIREMODE	74 
// "hostage_entity" entities
#define OFFSET_HOSTAGEFOLLOW		86
#define OFFSET_HOSTAGE_NEXTUSE		100
#define OFFSET_HOSTAGE_LASTUSE		483
#define OFFSET_HOSTAGEID		487
// "armoury_entity"
#define OFFSET_ARMOURY_TYPE		34 
// C4 offsets
#define OFFSET_C4_EXPLODE_TIME		100
#define OFFSET_C4_DEFUSING		0x181 

// These are used with armoury_entity:s.
#define CSA_MP5NAVY			0
#define CSA_TMP				1
#define CSA_P90				2
#define CSA_MAC10			3
#define CSA_AK47			4
#define CSA_SG552			5
#define CSA_M4A1			6
#define CSA_AUG				7
#define CSA_SCOUT			8
#define CSA_G3SG1			9
#define CSA_AWP				10
#define CSA_M3				11
#define CSA_XM1014			12
#define CSA_M249			13
#define CSA_FLASHBANG			14
#define CSA_HEGRENADE			15
#define CSA_VEST			16
#define CSA_VESTHELM			17
#define CSA_SMOKEGRENADE		18

#define M4A1_SILENCED			(1<<2)
#define M4A1_ATTACHSILENCEANIM		6
#define M4A1_DETACHSILENCEANIM		13
#define USP_SILENCED			(1<<0)
#define USP_ATTACHSILENCEANIM		7
#define USP_DETACHSILENCEANIM		15

#define GLOCK_SEMIAUTOMATIC		0
#define GLOCK_BURSTMODE			2
#define FAMAS_AUTOMATIC			0
#define FAMAS_BURSTMODE			16

#define PLAYER_IS_VIP			(1<<8)

#define PLAYER_IN_BUYZONE		(1<<0)

#define TEAM_UNASSIGNED			0
#define TEAM_T				1
#define TEAM_CT				2
#define TEAM_SPECTATOR			3

#define CAN_PLANT_BOMB			(1<<8) 
#define HAS_DEFUSE_KIT			(1<<16) 

#define DEFUSER_COLOUR_R		0
#define DEFUSER_COLOUR_G		160
#define DEFUSER_COLOUR_B		0

#define HAS_NVGOGGLES			(1<<0)
#define HAS_SHIELD     			(1<<24) 

#define SCOREATTRIB_NOTHING		0
#define SCOREATTRIB_DEAD		1
#define SCOREATTRIB_BOMB		2 
#define SCOREATTRIB_VIP			4 

#define CS_FIRST_ZOOM			0x28
#define CS_SECOND_AWP_ZOOM		0xA
#define CS_SECOND_NONAWP_ZOOM		0xF
#define CS_AUGSG552_ZOOM		0x37
#define CS_NO_ZOOM			0x5A

enum CS_Internal_Models 
{
	CS_DONTCHANGE = 0,
	CS_CT_URBAN = 1,
	CS_T_TERROR = 2,
	CS_T_LEET = 3,
	CS_T_ARCTIC = 4,
	CS_CT_GSG9 = 5,
	CS_CT_GIGN = 6,
	CS_CT_SAS = 7,
	CS_T_GUERILLA = 8,
	CS_CT_VIP = 9,
	CZ_T_MILITIA = 10,
	CZ_CT_SPETSNAZ = 11
};


enum
{
	CS_RESET_ZOOM = 0,
	CS_SET_NO_ZOOM,
	CS_SET_FIRST_ZOOM,
	CS_SET_SECOND_ZOOM,
	CS_SET_AUGSG552_ZOOM,
};


enum CsTeams 
{
	CS_TEAM_UNASSIGNED = 0,
	CS_TEAM_T = 1,
	CS_TEAM_CT = 2,
	CS_TEAM_SPECTATOR = 3
};


enum CsArmorType 
{
	CS_ARMOR_NONE = 0, 
	CS_ARMOR_KEVLAR = 1, 
	CS_ARMOR_VESTHELM = 2 
};


/********************************** FM_SET_* Stocks ********************************************/


/* fm_set_user_money - Sets a user's money count. */
/* If flash is set to 0, the difference between the old and new money will NOT flash.  */
stock fm_set_user_money(index, money, flash = 1)
{
	set_pdata_int(index, OFFSET_CSMONEY, money);
	
	message_begin(MSG_ONE, get_user_msgid("Money"), {0,0,0}, index);
	write_long(money);
	write_byte(flash ? 1 : 0);
	message_end();
}


/* Sets a user's deaths with amount of 'new_deaths'	 */
/* This function also cares about updating the score table on clients. */
stock fm_set_user_deaths(id, new_deaths)
{
	set_pdata_int(id, OFFSET_CSDEATHS, new_deaths);

	message_begin(MSG_ALL, get_user_msgid("ScoreInfo"));
	write_byte(id);
	new Float:frags;
	pev(id, pev_frags, frags);
	write_short(floatround(frags));
	write_short(new_deaths);
	write_short(0);
	write_short(get_pdata_int(id, OFFSET_TEAM));
	message_end();
}


/* fm_set_weapon_silen - Sets whether a weapon is silenced or not. */
/* @weapon_id should be the entity index of the weapon	*/
/* This only works on the USP or M4A1. 	*/
stock fm_set_weapon_silen(weapon_id, silence = 1, draw_animation = 1)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}

	new weapontype, silencemode, owner;
	weapontype = get_pdata_int(weapon_id, OFFSET_WEAPONTYPE, EXTRAOFFSET_WEAPONS)
	silencemode = get_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, EXTRAOFFSET_WEAPONS)

	switch(weapontype)
	{
		case CSW_M4A1: 
		{
			if(silence == 1) 
			{
				if(!(silencemode & M4A1_SILENCED)) 
				{
					silencemode |= M4A1_SILENCED;
					set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, EXTRAOFFSET_WEAPONS);
					owner = pev(weapon_id, pev_owner);
					
					if(draw_animation && fm_is_player(owner))
						set_pev(owner, pev_weaponanim, M4A1_ATTACHSILENCEANIM);
				}
			}
		
			else if(silencemode & M4A1_SILENCED) 
			{
				silencemode &= ~M4A1_SILENCED;
				set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, EXTRAOFFSET_WEAPONS);
				owner = pev(weapon_id, pev_owner);
				
				if(draw_animation && fm_is_player(owner))
					set_pev(owner, pev_weaponanim, M4A1_DETACHSILENCEANIM);
			}
		}
		
		case CSW_USP: 
		{
			if(silence == 1) 
			{
				if(!(silencemode & USP_SILENCED)) 
				{
					silencemode |= USP_SILENCED;
					set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, EXTRAOFFSET_WEAPONS);
					owner = pev(weapon_id, pev_owner);
					
					if(draw_animation && fm_is_player(owner))
						set_pev(owner, pev_weaponanim, USP_ATTACHSILENCEANIM);
				}
			}
			
			else if(silencemode & USP_SILENCED) 
			{
				silencemode &= ~USP_SILENCED;
				set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, silencemode, EXTRAOFFSET_WEAPONS);
				owner = pev(weapon_id, pev_owner);
				
				if(draw_animation && fm_is_player(owner))
					set_pev(owner, pev_weaponanim, USP_DETACHSILENCEANIM);
			}
		}
		default: return 0;
	}
	return 1;
}


/* fm_set_weapon_burst - Sets whether the weapon is in burst mode.  */
/* @weapon_id should be the entity index of the weapon */
/* This only works on the Glock and FAMAS.   */
stock fm_set_weapon_burst(weapon_id, burstmode = 1)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	new weapontype = get_pdata_int(weapon_id, OFFSET_WEAPONTYPE, EXTRAOFFSET_WEAPONS);
	new firemode = get_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, EXTRAOFFSET_WEAPONS);
	new previousMode = firemode;

	switch (weapontype)
	{
		case CSW_GLOCK18: 
		{
			if(burstmode) 
			{
				if (previousMode != GLOCK_BURSTMODE) 
				{
					firemode = GLOCK_BURSTMODE;
					set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, EXTRAOFFSET_WEAPONS);

					new owner = pev(weapon_id, pev_owner);
					
					if(fm_is_player(owner)) 
					{
						message_begin(MSG_ONE, get_user_msgid("TextMsg"), _, owner);
						write_byte(4);
						write_string("#Switch_To_BurstFire");
						message_end();
					}
				}
			}
			else if (previousMode != GLOCK_SEMIAUTOMATIC) 
			{
				firemode = GLOCK_SEMIAUTOMATIC;
				set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, EXTRAOFFSET_WEAPONS);

				new owner = pev(weapon_id, pev_owner);
				if(fm_is_player(owner)) 
				{
					message_begin(MSG_ONE, get_user_msgid("TextMsg"), _, owner);
					write_byte(4);
					write_string("#Switch_To_SemiAuto");
					message_end();
				}
			}
		}

		case CSW_FAMAS: 
		{
			if (burstmode) 
			{
				if (previousMode != FAMAS_BURSTMODE) 
				{
					firemode = FAMAS_BURSTMODE;
					set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, EXTRAOFFSET_WEAPONS);

					new owner = pev(weapon_id, pev_owner);
					if(fm_is_player(owner)) 
					{
						message_begin(MSG_ONE, get_user_msgid("TextMsg"), _, owner);
						write_byte(4);
						write_string("#Switch_To_BurstFire");
						message_end();
					}
				}
			}
			else if (previousMode != FAMAS_AUTOMATIC) 
			{
				firemode = FAMAS_AUTOMATIC;
				set_pdata_int(weapon_id, OFFSET_SILENCER_FIREMODE, firemode, EXTRAOFFSET_WEAPONS);

				new owner = pev(weapon_id, pev_owner);
				if(fm_is_player(owner)) 
				{
					message_begin(MSG_ONE, get_user_msgid("TextMsg"), _, owner);
					write_byte(4);
					write_string("#Switch_To_FullAuto");
					message_end();
				}
			}
		}

		default: return 0;
	}
	return 1;
}


/* fm_set_user_armor - Sets player armor */
/* Use this instead of fun's set_user_armor if playing Counter-Strike. 
Appropriate message to update client's HUD will be sent if armortype is kevlar or vesthelm. */
/* The following armor types are available: */
//	CS_ARMOR_NONE = 0, // no armor
//	CS_ARMOR_KEVLAR = 1, // armor
//	CS_ARMOR_VESTHELM = 2 // armor and helmet 
stock fm_set_user_armor(id, armorvalue, CsArmorType:armortype)
{
	switch(armortype) 
	{
		case CS_ARMOR_NONE: set_pdata_int(id, OFFSET_ARMORTYPE, 0);
		case CS_ARMOR_KEVLAR: set_pdata_int(id, OFFSET_ARMORTYPE, 1);
		case CS_ARMOR_VESTHELM: set_pdata_int(id, OFFSET_ARMORTYPE, 2);
	}

	set_pev(id, pev_armorvalue, float(armorvalue));
	
	if(armortype == CS_ARMOR_KEVLAR || armortype == CS_ARMOR_VESTHELM)
	{
		message_begin(MSG_ONE, get_user_msgid("ArmorType"), _, id);
		write_byte((armortype == CS_ARMOR_VESTHELM) ? 1 : 0);
		message_end();
	}
}


/* fm_set_user_vip - Sets whether a user is the VIP. */
/* The model will be changed to VIP model if 1, else it will be changed to a random CT model.  */
/* If model = 1, then user's model will be changed to VIP model or random CT model if vip = 0. */
/* If scoreboard = 1, then scoreboard will be updated to show that user is VIP. */
/* This shouldn't be used for players on teams other than CT. */
/* This is mostly useful for unsetting vips, so they can change teams and/or buy items properly. 
It does not alter game play; the one being VIP at start of round will retain internal status as VIP; 
terrorists can terminate him and accomplish their objective, etc. */
stock fm_set_user_vip(id, vip = 1, model = 1, scoreboard = 1)
{
	if(vip == 1)
	{
		set_pdata_int(id, OFFSET_VIP, get_pdata_int(id, OFFSET_VIP) | PLAYER_IS_VIP);
		
		if(model == 1) 
		{
			set_pdata_int(id, OFFSET_INTERNALMODEL, CS_CT_VIP);
			dllfunc(DLLFunc_ClientUserInfoChanged, id);
		}
		
		if(scoreboard == 1)
		{
			message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"));
			write_byte(id);
			write_byte(SCOREATTRIB_VIP);
			message_end();
		}
	}

	else
	{
		set_pdata_int(id, OFFSET_VIP, get_pdata_int(id, OFFSET_VIP) & ~PLAYER_IS_VIP);

		if(model == 1)
		{
			new CS_Internal_Models:CTmodels[4] = {CS_CT_URBAN, CS_CT_GSG9, CS_CT_GIGN, CS_CT_SAS}
			new CS_Internal_Models:ct_model = CTmodels[random_num(0, 3)];
			set_pdata_int(id, OFFSET_INTERNALMODEL, CTenum[randnum]);
			dllfunc(DLLFunc_ClientUserInfoChanged, id);
		}

		if(scoreboard == 1)
		{
			new scoreattrib, Float:health;
			pev(id, pev_health, health);

			if(pev(id, pev_deadflag) == DEAD_NO && health > 0.0)
				scoreattrib = SCOREATTRIB_NOTHING;
				
			else
				scoreattrib = SCOREATTRIB_DEAD;
				
			message_begin(MSG_ALL, get_user_msgid("ScoreAttrib"));
			write_byte(id);
			write_byte(scoreattrib);
			message_end();
		}
	}

	return 1;
}



/* fm_set_user_team - Sets a CS player's team without killing the player. */
/* Team values are CS_TEAM_T, CS_TEAM_CT, or CS_TEAM_SPECTATOR. */
/* You can optionally set a model:
CS_DONTCHANGE, CS_CT_URBAN, CS_T_TERROR, CS_T_LEET, CS_T_ARCTIC
CS_CT_GSG9, CS_CT_GIGN, CS_CT_SAS ,CS_T_GUERILLA, CS_CT_VIP */
stock fm_set_user_team(id, {CsTeams,_}:team, {CS_Internal_Models,_}:model = CS_DONTCHANGE)
{
	switch(team)
	{
		case CS_TEAM_T: set_pdata_int(id, OFFSET_TEAM, 1);
		case CS_TEAM_CT: set_pdata_int(id, OFFSET_TEAM, 2);
		case CS_TEAM_SPECTATOR: set_pdata_int(id, OFFSET_TEAM, 3);
	}

	if(model)
	{
		switch(model)
		{
			case CS_CT_URBAN:set_pdata_int(id, OFFSET_INTERNALMODEL, 1);
			case CS_T_TERROR:set_pdata_int(id, OFFSET_INTERNALMODEL, 2);
			case CS_T_LEET:set_pdata_int(id, OFFSET_INTERNALMODEL, 3);
			case CS_T_ARCTIC:set_pdata_int(id, OFFSET_INTERNALMODEL, 4);
			case CS_CT_GSG9:set_pdata_int(id, OFFSET_INTERNALMODEL, 5);
			case CS_CT_GIGN:set_pdata_int(id, OFFSET_INTERNALMODEL, 6);
			case CS_CT_SAS:set_pdata_int(id, OFFSET_INTERNALMODEL, 7);
			case CS_T_GUERILLA:set_pdata_int(id, OFFSET_INTERNALMODEL, 8);
			case CS_CT_VIP:set_pdata_int(id, OFFSET_INTERNALMODEL, 9);
			case CZ_T_MILITIA:set_pdata_int(id, OFFSET_INTERNALMODEL, 10);
			case CZ_CT_SPETSNAZ:set_pdata_int(id, OFFSET_INTERNALMODEL, 11);
		}
	}

	dllfunc(DLLFunc_ClientUserInfoChanged, id);

	new teaminfo[32];
	switch(team)
	{
		case TEAM_UNASSIGNED: copy(teaminfo, 31, "UNASSIGNED")
		case TEAM_T: copy(teaminfo, 31, "TERRORIST")
		case TEAM_CT: copy(teaminfo, 31, "CT")
		case TEAM_SPECTATOR: copy(teaminfo, 31, "SPECTATOR")
		
	}
	
	message_begin(MSG_ALL, get_user_msgid("TeamInfo"));
	write_byte(id);
	write_string(teaminfo);
	message_end();

}


/* fm_set_user_plant - Sets whether a player can plant the bomb. */
/* This will only work if the player is at a bomb site and has the bomb. You should use this if you give a player weapon_c4 manually. */
/* If showbombicon is 1, the green C4 icon will be shown on the user's HUD.  */
stock fm_set_user_plant(id, plant = 1, showbombicon = 1)
{
	new plantskill = get_pdata_int(id, OFFSET_DEFUSE_PLANT);

	if(plant)
	{
		plantskill |= CAN_PLANT_BOMB;
		set_pdata_int(id, OFFSET_DEFUSE_PLANT, plantskill);
		
		if(showbombicon)
		{
			message_begin(MSG_ONE, get_user_msgid("StatusIcon"), _, id);
			write_byte(1);
			write_string("c4");
			write_byte(DEFUSER_COLOUR_R);
			write_byte(DEFUSER_COLOUR_G);
			write_byte(DEFUSER_COLOUR_B);
			message_end();
		}
	}
	else
	{
		plantskill &= ~CAN_PLANT_BOMB;
		set_pdata_int(id, OFFSET_DEFUSE_PLANT, plantskill);
		message_begin(MSG_ONE, get_user_msgid("StatusIcon"), _, id);
		write_byte(0);
		write_string("c4");
		message_end();
	}
}


/* fm_set_user_defuse - Sets whether a user has the defusekit. */
/* If defusekit is 1, the user will have a defuse kit. */
/* You can specify the status icon. Default is "defuser". Flash (defaults to 0) can be set to flash the item red.  */
/* You can also specify the status icon color (defaults to green, r=0, g=160, b=0). */
stock fm_set_user_defuse(id, defusekit = 1, r = DEFUSER_COLOUR_R, g = DEFUSER_COLOUR_G, b = DEFUSER_COLOUR_B, icon[] = "defuser", flash = 0)
{
	new defuse = get_pdata_int(id, OFFSET_DEFUSE_PLANT);

	if(defusekit)
	{
		new colour[3] = {DEFUSER_COLOUR_R, DEFUSER_COLOUR_G, DEFUSER_COLOUR_B}
		if(r != -1) colour[0] = r;
		if(g != -1) colour[1] = g;
		if(b != -1) colour[2] = b;
    
    		set_pev(id, pev_body, 1);

		defuse |= HAS_DEFUSE_KIT;
		set_pdata_int(id, OFFSET_DEFUSE_PLANT, defuse);
		
		message_begin(MSG_ONE, get_user_msgid("StatusIcon"), _, id);
		write_byte((flash == 1) ? 2 : 1);
		write_string(icon[0] ? icon : "defuser");
		write_byte(colour[0]);
		write_byte(colour[1]);
		write_byte(colour[2]);
		message_end();
	}

	else
	{
		defuse &= ~HAS_DEFUSE_KIT;
		set_pdata_int(id, OFFSET_DEFUSE_PLANT, defuse);
		message_begin(MSG_ONE, get_user_msgid("StatusIcon"), _, id);
		write_byte(0);
		write_string("defuser");
		message_end();
		
		set_pev(id, pev_body, 0);
	}
}


/* fm_set_user_tked - Sets whether or not specified user has TKed (team killed). */
/* If tk is 1 then player has tked, otherwise not.  */
/* Set subtract to how many frags to subtract. Set subtract to a negative value to add frags.  */
stock fm_set_user_tked(id, tk = 1, subtract = 1)
{
	if(tk) set_pdata_int(id, OFFSET_TK, 1);
	
	else set_pdata_int(id, OFFSET_TK, 0);

	if(subtract)
	{
		new Float:frags;
		pev(id, pev_frags, frags);
		pev(id, pev_frags, frags - float(subtract));

		message_begin(MSG_ALL, get_user_msgid("ScoreInfo"));
		write_byte(id);
		write_short(floatround(frags));
		write_short(get_pdata_int(id, OFFSET_CSDEATHS));
		write_short(0);
		write_short(get_pdata_int(id, OFFSET_TEAM));
		message_end();
	}
}


/*  fm_set_user_backpackammo - Restock/remove ammo in a user's backpack for a specific weapon.  */
/* EXAMPLE : fm_set_user_backpackammo(id, CSW_M4A1, 90); */
/* EXAMPLE 2 : fm_set_user_backpackammo(id, CSW_MP5NAVY, 120); */
stock fm_set_user_bpammo(index, weapon, amount)
{
	new offset;
	
	switch(weapon)
	{
		case CSW_AWP: offset = OFFSET_AWM_AMMO;
		case CSW_SCOUT,CSW_AK47,CSW_G3SG1: offset = OFFSET_SCOUT_AMMO;
		case CSW_M249: offset = OFFSET_PARA_AMMO;
		case CSW_M4A1,CSW_FAMAS,CSW_AUG,CSW_SG550,CSW_GALI,CSW_SG552: offset = OFFSET_FAMAS_AMMO;
		case CSW_M3,CSW_XM1014: offset = OFFSET_M3_AMMO;
		case CSW_USP,CSW_UMP45,CSW_MAC10: offset = OFFSET_USP_AMMO;
		case CSW_FIVESEVEN,CSW_P90: offset = OFFSET_FIVESEVEN_AMMO;
		case CSW_DEAGLE: offset = OFFSET_DEAGLE_AMMO;
		case CSW_P228: offset = OFFSET_P228_AMMO;
		case CSW_GLOCK18,CSW_MP5NAVY,CSW_TMP,CSW_ELITE: offset = OFFSET_GLOCK_AMMO;
		case CSW_FLASHBANG: offset = OFFSET_FLASH_AMMO;
		case CSW_HEGRENADE: offset = OFFSET_HE_AMMO;
		case CSW_SMOKEGRENADE: offset = OFFSET_SMOKE_AMMO;
		case CSW_C4: offset = OFFSET_C4_AMMO;

		default:
		{
			new invalidMsg[20 + 7];
			formatex(invalidMsg,20 + 6,"Invalid weapon id %d",weapon);
			set_fail_state(invalidMsg);
			
			return 0;
		}
	}
	
	set_pdata_int(index,offset,amount);
	
	return 1;
}


/* fm_set_hostage_foll - Sets what a hostage follows.  */
/* @hostage_id is a hostage entity index. */
/* If the entity index is set to 0 (default), the hostage will stop following anything.  */
/* NOTE : This does not work on Condition Zero. */
/* NOTE 2 : Hostage wont be rescued untill CT uses him. He will just be standing @ the rescue zone. - Thanks anssik93 */
stock fm_set_hostage_foll(hostage_id, followedid = 0)
{
	new classname[32];
	pev(hostage_id, pev_classname, classname, 31);
	
	if(!equal(classname,"hostage_entity"))
		return 0;

	if(followedid == 0)
	{
		set_pdata_int(hostage_id, OFFSET_HOSTAGEFOLLOW, 0);
		return 1;
	}

	set_pdata_int(hostage_id, OFFSET_HOSTAGEFOLLOW, followedid);
	return 1;
}


/* fm_set_user_nvg - Sets whether a user has night vision goggles. */
stock fm_set_user_nvg(index, nvgoggles = 1)
{
	new kit = get_pdata_int(index,OFFSET_NVGOGGLES);
	
	if(nvgoggles)
	{
		if(kit & HAS_NVGOGGLES)
			client_print(index,print_center,"#Already_Have_One");
	
		else kit |= HAS_NVGOGGLES;
	}
	else kit &= ~HAS_NVGOGGLES;
	
	return 1;
}


/* fm_set_armoury_type - Set armoury tipe */
stock fm_set_armoury_type(ent_id, type)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	new classname[32];
	pev(ent_id, pev_classname, classname, 31);
	
	if(!equal(classname,"armoury_entity"))	
		return 0;

	new weapontype = get_pdata_int(ent_id, OFFSET_ARMOURY_TYPE, EXTRAOFFSET_WEAPONS);

	new weapontype_out;
	
	switch(weapontype)
	{
		case CSA_MP5NAVY: 	weapontype_out = CSW_MP5NAVY;
		case CSA_TMP: 		weapontype_out = CSW_TMP;
		case CSA_P90: 		weapontype_out = CSW_P90;
		case CSA_MAC10: 	weapontype_out = CSW_MAC10;
		case CSA_AK47:     	weapontype_out = CSW_AK47;
		case CSA_SG552:      	weapontype_out = CSW_SG552;
		case CSA_M4A1:      	weapontype_out = CSW_M4A1;
		case CSA_AUG:         	weapontype_out = CSW_AUG;
		case CSA_SCOUT:         	weapontype_out = CSW_SCOUT;
		case CSA_G3SG1:         	weapontype_out = CSW_G3SG1;
		case CSA_AWP:           	weapontype_out = CSW_AWP;
		case CSA_M3:            	weapontype_out = CSW_M3;
		case CSA_XM1014:        	weapontype_out = CSW_XM1014;
		case CSA_M249:          	weapontype_out = CSW_M249;
		case CSA_FLASHBANG:     	weapontype_out = CSW_FLASHBANG;
		case CSA_HEGRENADE:     	weapontype_out = CSW_HEGRENADE;
		case CSA_VEST:          	weapontype_out = CSW_VEST;
		case CSA_VESTHELM:     	weapontype_out = CSW_VESTHELM;
		case CSA_SMOKEGRENADE:  	weapontype_out = CSW_SMOKEGRENADE;
		default: return 0;
	}

	set_pdata_int(ent_id, OFFSET_ARMOURY_TYPE, weapontype_out, EXTRAOFFSET_WEAPONS);

	return 1;
}



/*  fm_set_user_hostagekills - Set user's hostage kills passed with 'value' */
stock fm_set_user_hostagekills(id, value)
{
	set_pdata_int(id, OFFSET_HOSTAGEKILLS, value);
}


/*  fm_set_weapon_ammo - Sets the amount of ammo in weapon's clip. */
/* EXAMPLE by potatis_invalido: 
new weapon_id = find_ent_by_owner(-1, "weapon_ak47", id);
if(weapon_id) fm_set_weapon_ammo(weapon_id, 50); */
stock fm_set_weapon_ammo(weapon_id, newammo)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	set_pdata_int(weapon_id, OFFSET_CLIPAMMO, newammo, EXTRAOFFSET_WEAPONS);
}




/********************************** FM_GET_* Stocks ********************************************/


/* fm_get_user_money - Returns a user's money. */
stock fm_get_user_money(index)
{
	return get_pdata_int(index, OFFSET_CSMONEY);
}


/* fm_get_user_deaths - Returns a user's deaths */
stock fm_get_user_deaths(index)
{
	return get_pdata_int(index, OFFSET_CSDEATHS);
}




/* fm_get_hostage_id - Returns the unique hostage ID of a hostage entity. */
stock fm_get_hostage_id(hostageINDEX)
{
	new classname[32];
	pev(hostageINDEX, pev_classname, classname, 31);

	if(!equal(classname,"hostage_entity"))
		return 0;

	return get_pdata_int(hostageINDEX, OFFSET_HOSTAGEID);
}


/* fm_get_weapon_sile - Returns 1 if a weapon is silenced, 0 otherwise. */
stock fm_get_weapon_silen(index)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	new weapontype, silencemode;
	weapontype = get_pdata_int(index, OFFSET_WEAPONTYPE, EXTRAOFFSET_WEAPONS);
	silencemode = get_pdata_int(index, OFFSET_SILENCER_FIREMODE, EXTRAOFFSET_WEAPONS);
	
	switch(weapontype) 
	{
		case CSW_USP:
		{
			if(silencemode & USP_SILENCED)
				return 1;
		}
		
		case CSW_M4A1:
		{
			if(silencemode & M4A1_SILENCED)
				return 1;
		}
	}
	
	return 0;
}


/* fm_get_weapon_id - Get weapon type. */
/* @weapon_id is the entity index of the weapon */
/* returns corresponding CSW_* constant in amxconst.inc. */
stock fm_get_weapon_id(weapon_id)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	return get_pdata_int(weapon_id, OFFSET_WEAPONTYPE, EXTRAOFFSET_WEAPONS)
}



/* fm_get_weapon_burst - Returns 1 if the weapon is in burst mode, 0 otherwise. */
/* @weaponID should be the entity index of the weapon */
stock fm_get_weapon_burst(weaponID)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	new weapontype, firemode;
	weapontype = get_pdata_int(weaponID, OFFSET_WEAPONTYPE, EXTRAOFFSET_WEAPONS);
	firemode = get_pdata_int(weaponID, OFFSET_SILENCER_FIREMODE, EXTRAOFFSET_WEAPONS);
	
	switch(weapontype)
	{
		case CSW_GLOCK18: 
		{
			if(firemode == GLOCK_BURSTMODE)
				return 1;
		}
		
		case CSW_FAMAS:
		{
			if(firemode == FAMAS_BURSTMODE)
				return 1;
		}
	}
	return 0;
}




/* fm_get_user_armor - Returns armor value and armor type (by reference). */
/* armortype will return the armor type passed by reference. (See CS Armor Constants for types)  */
/* Example:			*/
//	new CsArmorType:ArmorType
//	new Armor = cs_get_user_armor(id, ArmorType) 
stock fm_get_user_armor(id, &CsArmorType:armortype)
{
	switch(get_pdata_int(id, OFFSET_ARMORTYPE))
	{
		case 0: armortype = CS_ARMOR_NONE;
		case 1: armortype = CS_ARMOR_KEVLAR;
		case 2: armortype = CS_ARMOR_VESTHELM;
	}
	
	return floatround(pev(id, pev_armorvalue)));
}



/* fm_get_user_vip - Returns 1 is 'id' is VIP; 0 if not */
stock fm_get_user_vip(id)
{
	if(get_pdata_int(id, OFFSET_VIP) & PLAYER_IS_VIP)
		return 1;
		
	return 0;
}



/* fm_get_user_team - Gets a user's CS team.  */
/* Return type is CsTeams, which means you have to declare your variable as CsTeams:name, just as you declare a float as Float:name */
/* Return values are CS_TEAM_T, CS_TEAM_CT, or CS_TEAM_SPECTATOR, CS_TEAM_UNASSIGNED. */
/* This function returns constants that are interpreted as 1 being Terrorist, 2 being Counter-Terrorist, and 3 being Spectator. - Avalanche */
stock CsTeams:fm_get_user_team(id, &{CS_Internal_Models,_}:model = CS_DONTCHANGE)
{
	model = CS_Internal_Models:get_pdata_int(id, OFFSET_INTERNALMODEL);

	return CsTeams:get_pdata_int(id, OFFSET_TEAM);
}


/* fm_get_user_buyzone - Returns 1 if a player is in a buyzone, 0 otherwise.  */
stock fm_get_user_buyzone(id)
{
	if(get_pdata_int(id, OFFSET_MAPZONE) & PLAYER_IN_BUYZONE)
		return 1;
		
	return 0;
}


/* fm_get_user_mapzones - Returns in bitwise form if the user is in a specific map zone. */
/* Use the following defines to check for specific zones:	*/
//	#define CS_MAPZONE_BUY (1<<0)
//	#define CS_MAPZONE_BOMBTARGET (1<<1)
//	#define CS_MAPZONE_HOSTAGE_RESCUE (1<<2)
//	#define CS_MAPZONE_ESCAPE (1<<3)
//	#define CS_MAPZONE_VIP_SAFETY (1<<4)
//  If user can't plant (cs_get_user_plant(index) is 0) then cs_get_user_mapzones(index) & CS_MAPZONE_BOMBTARGET will return 0 too. 
stock fm_get_user_mapzones(id) 
{
	return get_pdata_int(id, OFFSET_MAPZONE)
}


/* fm_get_user_plant - Returns 1 if a player can plant the bomb. */
stock fm_get_user_plant(id)
{
	if(get_pdata_int(id, OFFSET_DEFUSE_PLANT) & CAN_PLANT_BOMB)
		return 1;
		
	return 0;
}


/* fm_get_user_defuse - Returns 1 if a user has a defuse kit, 0 otherwise.  */
stock fm_get_user_defuse(id)
{
	if(get_pdata_int(id, OFFSET_DEFUSE_PLANT) & HAS_DEFUSE_KIT)
		return 1;

	return 0;
}


/* fm_get_user_tked - Returns 1 if specified user has TKed (team killed). */
stock fm_get_user_tked(id)
{
	return get_pdata_int(id, OFFSET_TK);
}


/* fm_get_user_backpackammo - Returns the amount of ammo in a player's backpack for a specific weapon.  */
stock fm_get_user_bpammo(index, weapon)
{
	new offset;
	
	switch(weapon)
	{
		case CSW_AWP: offset = OFFSET_AWM_AMMO;
		case CSW_SCOUT,CSW_AK47,CSW_G3SG1: offset = OFFSET_SCOUT_AMMO;
		case CSW_M249: offset = OFFSET_PARA_AMMO;
		case CSW_M4A1,CSW_FAMAS,CSW_AUG,CSW_SG550,CSW_GALI,CSW_SG552: offset = OFFSET_FAMAS_AMMO;
		case CSW_M3,CSW_XM1014: offset = OFFSET_M3_AMMO;
		case CSW_USP,CSW_UMP45,CSW_MAC10: offset = OFFSET_USP_AMMO;
		case CSW_FIVESEVEN,CSW_P90: offset = OFFSET_FIVESEVEN_AMMO;
		case CSW_DEAGLE: offset = OFFSET_DEAGLE_AMMO;
		case CSW_P228: offset = OFFSET_P228_AMMO;
		case CSW_GLOCK18,CSW_MP5NAVY,CSW_TMP,CSW_ELITE: offset = OFFSET_GLOCK_AMMO;
		case CSW_FLASHBANG: offset = OFFSET_FLASH_AMMO;
		case CSW_HEGRENADE: offset = OFFSET_HE_AMMO;
		case CSW_SMOKEGRENADE: offset = OFFSET_SMOKE_AMMO;
		case CSW_C4: offset = OFFSET_C4_AMMO;
		default:
		{
			new invalidMsg[20 + 7];
			formatex(invalidMsg,20 + 6,"Invalid weapon id %d",weapon);
			set_fail_state(invalidMsg);
			
			return 0;
		}
	}
	
	return get_pdata_int(index,offset);
	
}



/* fm_get_user_nvg - Returns 1 if player has NVG; 0 if not */
stock fm_get_user_nvg(id)
{
	if(get_pdata_int(id, OFFSET_NVGOGGLES) & HAS_NVGOGGLES)
		return 1;
		
	return 0
}




/* fm_get_user_model - Get user's model */
/* EXAMPLE : */
// new model[32];
// fm_get_user_model(id,model,31);
// if(equal(model,"leet")) 
// { client_print(0,print_chat,"WOW !! I Have an awesome model "); }
stock fm_get_user_model(id, model[], len)
{
	new buffer = engfunc(EngFunc_GetInfoKeyBuffer, id);
	engfunc(EngFunc_InfoKeyValue, buffer, "model", model, len);
}


/* fm_get_weapon_ammo - Returns the amount of ammo in a player's weapon clip. */
stock fm_get_weapon_ammo(weaponID)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	return get_pdata_int(weaponID, OFFSET_CLIPAMMO, EXTRAOFFSET_WEAPONS);
}



/* fm_get_user_hasprim - Returns 1 when user has a primary weapon OR a shield in inventory, otherwise 0.  */
stock fm_get_user_hasprim(id)
{
	return get_pdata_int(id, OFFSET_PRIMARYWEAPON);
}


/* fm_get_hostage_foll - Returns the index of an entity of which a hostage is following. */
stock fm_get_hostage_foll(hostageID)
{
	return get_pdata_int(hostageID, OFFSET_HOSTAGEFOLLOW);
}


/* fm_get_user_driving - Returns different values depending on if user is driving a vehicle. */
/* Return values: */
//	0: no driving
//	1: driving, but standing still
//	2-4: driving, different positive speeds
//	5: driving, negative speed (backing) 
stock fm_get_user_driving(index)
{
	return get_pdata_int(index, OFFSET_ISDRIVING);
}


/* fm_get_user_stationary - Returns 1 if user is using a stationary gun, else 0. */
stock fm_get_user_stationary(id)
{
	return get_pdata_int(id, OFFSET_STATIONARY);
}


/* fm_get_user_shield - Returns 1 if user has a shield, 0 otherwise  */
stock fm_get_user_shield(id)
{
	if (get_pdata_int(id, OFFSET_SHIELD) & HAS_SHIELD)
		return 1;
		
	return 0;
}


/* fm_get_armoury_type - Returns armoury type */
stock fm_get_armoury_type(ent_id)
{
	if(is_linux_server())
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS 4
	}
	else
	{
		#undef EXTRAOFFSET_WEAPONS
		#define EXTRAOFFSET_WEAPONS	0
	}
	
	new classname[32];
	pev(ent_id, pev_classname, classname, 31);
	
	if(!equal(classname,"armoury_entity"))	
		return 0;

	new weapontype = get_pdata_int(ent_id, OFFSET_ARMOURY_TYPE, EXTRAOFFSET_WEAPONS);

	new weapontype_out;
	
	switch(weapontype)
	{
		case CSA_MP5NAVY: 	weapontype_out = CSW_MP5NAVY;
		case CSA_TMP: 		weapontype_out = CSW_TMP;
		case CSA_P90: 		weapontype_out = CSW_P90;
		case CSA_MAC10: 	weapontype_out = CSW_MAC10;
		case CSA_AK47:     	weapontype_out = CSW_AK47;
		case CSA_SG552:      	weapontype_out = CSW_SG552;
		case CSA_M4A1:      	weapontype_out = CSW_M4A1;
		case CSA_AUG:         	weapontype_out = CSW_AUG;
		case CSA_SCOUT:         	weapontype_out = CSW_SCOUT;
		case CSA_G3SG1:         	weapontype_out = CSW_G3SG1;
		case CSA_AWP:           	weapontype_out = CSW_AWP;
		case CSA_M3:            	weapontype_out = CSW_M3;
		case CSA_XM1014:        	weapontype_out = CSW_XM1014;
		case CSA_M249:          	weapontype_out = CSW_M249;
		case CSA_FLASHBANG:     	weapontype_out = CSW_FLASHBANG;
		case CSA_HEGRENADE:     	weapontype_out = CSW_HEGRENADE;
		case CSA_VEST:          	weapontype_out = CSW_VEST;
		case CSA_VESTHELM:     	weapontype_out = CSW_VESTHELM;
		case CSA_SMOKEGRENADE:  	weapontype_out = CSW_SMOKEGRENADE;
		default: return 0;
	}
	return weapontype_out;
}


/* fm_get_user_zoom - Returns how a user is zooming during the stock call */
//	CS_RESET_ZOOM = 0, // Reset any zoom blocking (when using this type, mode has no effect)
//	CS_SET_NO_ZOOM, // Disable any sort of zoom (ie: to disable zoom in all weapons use this with mode=0)
//	CS_SET_FIRST_ZOOM, // Set first zoom (awp style)
//	CS_SET_SECOND_ZOOM, // Set second zoom (awp style)
//	CS_SET_AUGSG552_ZOOM, // Set aug/sg552 zoom style
//	Values correspond to the above defines, but will return 0 if an error occurred. 
stock fm_get_user_zoom(index)
{
	new value = get_pdata_int(index, OFFSET_ZOOMTYPE);
	switch (value)
	{
		case CS_NO_ZOOM:				return CS_SET_NO_ZOOM;
		case CS_FIRST_ZOOM:				return CS_SET_FIRST_ZOOM
		case CS_SECOND_AWP_ZOOM, CS_SECOND_NONAWP_ZOOM:	return CS_SET_SECOND_ZOOM;
		case CS_AUGSG552_ZOOM:				return CS_SET_AUGSG552_ZOOM;
	}
	return 0;
}




/* fm_get_user_hostagekills - Returns user hostage kills */
stock fm_get_user_hostagekills(index)
{
	return get_pdata_int(index, OFFSET_HOSTAGEKILLS);
}




/********************************** Other's Stocks ********************************************/
/* fm_user_spawn - Spawns a player */
/* Similar with fun native spawn() */
/* Stick with the native 'spawn' since this stock would need to be called twice for a player also, just like spawn... */
stock fm_user_spawn(id) 
{
	set_pev(id, pev_deadflag, DEAD_RESPAWNABLE);
	dllfunc(DLLFunc_Spawn, id);
	set_pev(id, pev_iuser1, 0);
}


/*  fm_is_player - Return 1 is 'index' is a 'player' entity; 0 if not */
stock fm_is_player(index)
{
	new class[32];
	pev(index,pev_classname,class,31);
	
	if(equal(class,"player"))
		return 1;
	
	return 0;
}

